# nie exitowac watkow gdy kolejka juz pusta ale jeszcze nie wszystko zrobione - powinny czekac

import os
import threading
import time
import random
import datetime
import sys
import subprocess


FILE_HOSTS = 'hosts.txt'
FILE_JOBS = 'jobs.txt'

"""
SSH = '/usr/bin/ssh -o LogLevel=ERROR -o BatchMode=yes -o ConnectTimeout=15 %s \"%s\" >/dev/null 2>/dev/null'
#SSH = '/usr/bin/ssh -o LogLevel=ERROR -o BatchMode=yes -o ConnectTimeout=15 -t %s \"%s\" >/dev/null 2>/dev/null'
CMD = 'cd mod/modularity; umask 007; nice ./evolve.sh %s'
"""

#SSH = '/usr/bin/ssh -o LogLevel=ERROR -o BatchMode=yes -o ConnectTimeout=15 %(HOST)s \"%(CMD)s\" >/dev/null 2>/dev/null'
#CMD = 'cd mod/modularity; umask 007; nice ./evolve.sh %s'

SSH = '%(CMD)s'
#CMD = 'cmd /c start "%(JOBCMD)s" /w cmd /c "cd z:\projects\phd\code\modularity\modularity & %(JOBCMD)s"'
CMD = '%(JOBCMD)s'

def readLines(filename, get=False):
	list = []
	lineno = []
	i = 0
	lines = open(filename).readlines()
	for line in lines:
		com = line.find(';')
		if com >= 0:
			line = line[0:com]
		line = line.strip()
		if len(line) > 0:
			list.append(line)
			lineno.append(i)
		i += 1
	if get:
		return list, lines, lineno
	else:
		return list


def checkAccessiblity(host):
	cmd = SSH % { 'HOST' : host, 'CMD' : "@echo" }
	retcode = subprocess.call(cmd, shell=True)
	return retcode != 255

def ensureAccessiblity(host, aLock):
	global exiting, hostAccessible
	
	aLock.acquire()
	
	accessibleTestSleepMin = 15
	accessibleTestSleepMax = 1000
	accessibleTestSleep = accessibleTestSleepMin

	qLock.acquire()
	accessible = hostAccessible[host]
	qLock.release()

	while not exiting and not accessible:
		accessible = checkAccessiblity(host)
		if not accessible:
			#print "Host %s is inaccessible! Waiting %d sec" % (host, accessibleTestSleep)
			print >> sys.stderr, "%s | %-10s: inaccessible! Retrying in %d sec" % (datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S'), host, accessibleTestSleep)
			time.sleep(accessibleTestSleep + random.random() * 5)
			accessibleTestSleep = accessibleTestSleep * 2
			if accessibleTestSleep > accessibleTestSleepMax:
				accessibleTestSleep = accessibleTestSleepMax
		else:
			#print "Host %s is accessible" % host
			print >> sys.stderr, "%s | %-10s: is now accessible" % (datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S'), host)
			accessible =  True
	qLock.acquire()
	hostAccessible[host] = accessible
	qLock.release()
	
	aLock.release()


def runJob(host, jobNo):
	#cmd = SSH % (host, CMD % jobs[jobNo])
	cmd = SSH % { 'HOST' : host, 'CMD' : CMD % { 'JOBCMD' : jobs[jobNo] } }
	retcode = subprocess.call(cmd, shell=True)
	return retcode


def threadFunc(host, aLock):
	global queue, queueTODO, exiting, qLock, jobs, hostAccessible
	
	qLock.acquire()
	hostAccessible[host] = False
	qLock.release()
	
	while not exiting:
		# check if host is accessible
		ensureAccessiblity(host, aLock)
		if exiting:
			break
		
		qLock.acquire()
		
		# get next job
		if len(queue) == 0:
			qLock.release()
			break	#all jobs done
		jobNo = queue.pop()
		qLock.release()
		
		# run this job
		print >> sys.stderr, "%s | %-10s: #%d (Ln:%d) started" % (datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S'), host, jobNo, jobsLineNo[jobNo])
		start = datetime.datetime.now()
		retcode = runJob(host, jobNo)
		end = datetime.datetime.now()
		
		success = retcode == 0
		connectionLost = retcode == 255
		
		qLock.acquire()
		if success:
			print >> sys.stderr, "%s | %-10s: #%d (Ln:%d) DONE in %s" % (end.strftime('%Y-%m-%d %H:%M:%S'), host, jobNo, jobsLineNo[jobNo], str(end-start))
			queueTODO -= 1
			if queueTODO == 0:
				# all jobs done
				exiting = True
			jobsLines[jobsLineNo[jobNo]] = ';' + host + ' @ ' + jobsLines[jobsLineNo[jobNo]]
		else:
			if connectionLost:
				print >> sys.stderr, "%s | %-10s: #%d (Ln:%d) FAILED! (connection lost)" % (datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S'), host, jobNo, jobsLineNo[jobNo])
			else:
				print >> sys.stderr, "%s | %-10s: #%d (Ln:%d) FAILED!" % (datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S'), host, jobNo, jobsLineNo[jobNo])
			
			jobAttempt[jobNo] += 1 # no of fails
			if jobAttempt[jobNo] < 10:
				# if error then add this jobNo to the queue
				queue.insert(0, jobNo)
			else:
				# abort this job (sth is wrong with this job)
				aborted.append(jobNo)
				queueTODO -= 1
			
			if connectionLost:
				hostAccessible[host] = False
		
		qLock.release()
		
		if success:
			time.sleep(1)
		else:
			time.sleep(10)


def printStatus():
	qLock.acquire()
	
	print >> sys.stderr, "/----------------------------------"
	print >> sys.stderr, "| %s" % datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S')
	print >> sys.stderr, "| done: ", len(jobs)-queueTODO, " TODO:", queueTODO, " running: ", queueTODO - len(queue)
	
	aHosts = []
	iHosts = []
	for h,a in hostAccessible.items():
		if a:
			aHosts.append(h)
		else:
			iHosts.append(h)
	
	attempts = [(jobAttempt[jobNo], jobNo) for jobNo in queue]
	attempts.sort()
	att = {}
	for a in attempts:
		if a[0] > 0:
			att[a[1]] = a[0]
	
	print >> sys.stderr, "| Accessible hosts (%d):" % len(aHosts), aHosts
	print >> sys.stderr, "| Inaccessible hosts (%d):" % len(iHosts), iHosts
	print >> sys.stderr, "| Failed jobs:", att
	print >> sys.stderr, "| Aborted jobs:", aborted
	
	#print >> sys.stderr, queue
	#print jobAttempt
	
	f = open(FILE_JOBS + ".done_tmp", 'w')
	try:
		f.writelines(jobsLines)
		f.flush()
	finally:
		f.close()
	try:
		os.rename(FILE_JOBS + ".done_tmp", FILE_JOBS + ".done")
	except OSError:
		os.unlink(FILE_JOBS + ".done")
		os.rename(FILE_JOBS + ".done_tmp", FILE_JOBS + ".done")

	print >> sys.stderr, "\----------------------------------"
	
	qLock.release()
	


### MAIN ####################################################

hosts = readLines(FILE_HOSTS)
jobs, jobsLines, jobsLineNo = readLines(FILE_JOBS, True)

hostNames = [l.split(None, 1)[0] for l in hosts]
hostCores = [int(l.split(None, 1)[1]) for l in hosts]

queue = range(len(jobs)-1, -1, -1)
queueTODO = len(queue)
exiting = False
qLock = threading.Lock()
aborted = []

hostAccessible = {}
jobAttempt = [0 for j in jobs]


print "Number of jobs:", len(jobs)
print "Number of hosts:", len(hostNames)

print "STARTING ===================="
for hostId in range(len(hostNames)):
	host = hostNames[hostId]
	cores = hostCores[hostId]
	#print host, cores
	
	aLock = threading.Lock()
	for c in range(cores):
		thr = threading.Thread(target=threadFunc, args=[host, aLock])
		thr.setDaemon(True)
		thr.setName(host)
		thr.start()

time.sleep(15)

while not exiting:
	printStatus()
	time.sleep(5*60)
printStatus()

